package javax.sound.sampled.spi;

import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioFormat;

public abstract class FormatConversionProvider
{
    public FormatConversionProvider() {
    }
    
    public abstract AudioFormat.Encoding[] getSourceEncodings();
    
    public abstract AudioFormat.Encoding[] getTargetEncodings();
    
    public boolean isSourceEncodingSupported(AudioFormat.Encoding encoding) {
        AudioFormat.Encoding[] sourceEncodings = this.getSourceEncodings();
        int i = 0;
        while (i < sourceEncodings.length) {
            if (encoding.equals(sourceEncodings[i])) {
                return true;
            }
            ++i;
        }
        return false;
    }
    
    public boolean isTargetEncodingSupported(AudioFormat.Encoding encoding) {
        AudioFormat.Encoding[] targetEncodings = this.getTargetEncodings();
        int i = 0;
        while (i < targetEncodings.length) {
            if (encoding.equals(targetEncodings[i])) {
                return true;
            }
            ++i;
        }
        return false;
    }
    
    public abstract AudioFormat.Encoding[] getTargetEncodings(AudioFormat p0);
    
    public boolean isConversionSupported(AudioFormat.Encoding encoding, AudioFormat audioFormat) {
        AudioFormat.Encoding[] targetEncodings = this.getTargetEncodings(audioFormat);
        int i = 0;
        while (i < targetEncodings.length) {
            if (encoding.equals(targetEncodings[i])) {
                return true;
            }
            ++i;
        }
        return false;
    }
    
    public abstract AudioFormat[] getTargetFormats(AudioFormat.Encoding p0, AudioFormat p1);
    
    public boolean isConversionSupported(AudioFormat audioFormat, AudioFormat audioFormat2) {
        AudioFormat[] targetFormats = this.getTargetFormats(audioFormat.getEncoding(), audioFormat2);
        int i = 0;
        while (i < targetFormats.length) {
            if (audioFormat.matches(targetFormats[i])) {
                return true;
            }
            ++i;
        }
        return false;
    }
    
    public abstract AudioInputStream getAudioInputStream(AudioFormat.Encoding p0, AudioInputStream p1);
    
    public abstract AudioInputStream getAudioInputStream(AudioFormat p0, AudioInputStream p1);
}
